UIPackage
Menu

Framework

Change language

Boilerplate repo

Json Tree View

json-tree-view ui
Boilerplate repo

Collapsible JSON tree viewer with color-coded value types, click-to-copy, live search/filter, and expand/collapse-all controls. Renders objects, arrays, and primitives with configurable depth and contained scrolling.

Also available for React ->

Installation

$ npx shadcn-vue@latest add https://uipkge.dev/r/vue/json-tree-view.json
Named registry: npx shadcn-vue@latest add @uipkge/json-tree-view Installs to: app/components/ui/json-tree-view/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
data JsonValue required
expandDepth number 1 optional
maxDepth number 100 optional
showSearch boolean true optional
showToolbar boolean true optional
rootLabel string 'root' optional
class HTMLAttributes['class'] optional

npm dependencies

Files installed (4)

  • app/components/ui/json-tree-view/JsonTreeView.vue 8.3 kB
    <script setup lang="ts">
    import type { HTMLAttributes } from 'vue'
    import { computed, ref, watch } from 'vue'
    import { Search, Braces, FoldVertical, UnfoldVertical } from 'lucide-vue-next'
    import { cn } from '@/lib/utils'
    import JsonTreeNode from './JsonTreeNode.vue'
    import type { JsonValue } from './types'
    
    export type { JsonValue } from './types'
    
    interface Props {
      data: JsonValue
      expandDepth?: number
      maxDepth?: number
      showSearch?: boolean
      showToolbar?: boolean
      rootLabel?: string
      class?: HTMLAttributes['class']
    }
    
    const props = withDefaults(defineProps<Props>(), {
      expandDepth: 1,
      maxDepth: 100,
      showSearch: true,
      showToolbar: true,
      rootLabel: 'root',
    })
    
    const emit = defineEmits<{
      copy: [value: string, path: string]
    }>()
    
    const expanded = ref<Set<string>>(new Set())
    const search = ref('')
    const copiedPath = ref<string | null>(null)
    
    function pathKey(path: (string | number)[]): string {
      return path.length ? path.map((p) => (typeof p === 'number' ? `[${p}]` : `.${p}`)).join('') : '$'
    }
    
    function defaultExpanded(): Set<string> {
      const next = new Set<string>()
      const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
        if (depth >= props.expandDepth) return
        if (val !== null && typeof val === 'object') {
          next.add(pathKey(path))
          const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
          for (const [k, v] of entries) {
            walk(v as JsonValue, [...path, k], depth + 1)
          }
        }
      }
      walk(props.data)
      return next
    }
    
    watch(
      () => [props.data, props.expandDepth],
      () => {
        expanded.value = defaultExpanded()
      },
      { immediate: true },
    )
    
    function toggle(path: (string | number)[]) {
      const key = pathKey(path)
      const next = new Set(expanded.value)
      if (next.has(key)) next.delete(key)
      else next.add(key)
      expanded.value = next
    }
    
    function isExpanded(path: (string | number)[]): boolean {
      return expanded.value.has(pathKey(path))
    }
    
    function expandAll() {
      const next = new Set<string>()
      const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
        if (depth >= props.maxDepth) return
        if (val !== null && typeof val === 'object') {
          next.add(pathKey(path))
          const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
          for (const [k, v] of entries) {
            walk(v as JsonValue, [...path, k], depth + 1)
          }
        }
      }
      walk(props.data)
      expanded.value = next
    }
    
    function collapseAll() {
      expanded.value = new Set()
    }
    
    // Auto-expand nodes that contain search matches
    watch(search, (q) => {
      if (!q) {
        expanded.value = defaultExpanded()
        return
      }
      const next = new Set<string>()
      const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
        if (depth >= props.maxDepth) return
        if (val !== null && typeof val === 'object') {
          if (matchesSearch(val)) next.add(pathKey(path))
          const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
          for (const [k, v] of entries) {
            walk(v as JsonValue, [...path, k], depth + 1)
          }
        }
      }
      walk(props.data)
      expanded.value = next
    })
    
    function matchesSearch(val: JsonValue): boolean {
      if (!search.value) return true
      const term = search.value.toLowerCase()
      const walk = (v: JsonValue): boolean => {
        if (v === null) return 'null'.includes(term)
        if (typeof v === 'string') return v.toLowerCase().includes(term)
        if (typeof v === 'number' || typeof v === 'boolean') return String(v).includes(term)
        if (Array.isArray(v)) return v.some(walk)
        if (typeof v === 'object') return Object.entries(v).some(([k, val]) => k.toLowerCase().includes(term) || walk(val))
        return false
      }
      return walk(val)
    }
    
    function typeOf(val: JsonValue): 'object' | 'array' | 'string' | 'number' | 'boolean' | 'null' {
      if (val === null) return 'null'
      if (Array.isArray(val)) return 'array'
      return typeof val as 'object' | 'string' | 'number' | 'boolean'
    }
    
    function formatValue(val: JsonValue): string {
      if (val === null) return 'null'
      if (typeof val === 'string') return JSON.stringify(val)
      return String(val)
    }
    
    const typeColor: Record<string, string> = {
      string: 'text-emerald-600 dark:text-emerald-400',
      number: 'text-blue-600 dark:text-blue-400',
      boolean: 'text-amber-600 dark:text-amber-400',
      null: 'text-muted-foreground italic',
      object: 'text-foreground',
      array: 'text-foreground',
    }
    
    const keyColor = 'text-violet-600 dark:text-violet-400'
    
    async function copyValue(val: JsonValue, path: (string | number)[]) {
      const str = typeof val === 'string' ? val : JSON.stringify(val, null, 2)
      const p = pathKey(path)
      try {
        await navigator.clipboard.writeText(str)
        copiedPath.value = p
        emit('copy', str, p)
        setTimeout(() => {
          if (copiedPath.value === p) copiedPath.value = null
        }, 1200)
      } catch {
        // clipboard unavailable
      }
    }
    
    const summary = computed(() => {
      const t = typeOf(props.data)
      if (t === 'array') return `Array(${(props.data as JsonValue[]).length})`
      if (t === 'object') return `Object(${Object.keys(props.data as object).length})`
      return t
    })
    
    const searchMatchCount = computed(() => {
      if (!search.value) return 0
      let count = 0
      const walk = (v: JsonValue) => {
        if (v === null) {
          if ('null'.includes(search.value.toLowerCase())) count++
          return
        }
        if (typeof v === 'string') {
          if (v.toLowerCase().includes(search.value.toLowerCase())) count++
          return
        }
        if (typeof v === 'number' || typeof v === 'boolean') {
          if (String(v).includes(search.value)) count++
          return
        }
        if (Array.isArray(v)) {
          v.forEach(walk)
          return
        }
        if (typeof v === 'object') {
          Object.entries(v).forEach(([k, val]) => {
            if (k.toLowerCase().includes(search.value.toLowerCase())) count++
            walk(val)
          })
        }
      }
      walk(props.data)
      return count
    })
    </script>
    
    <template>
      <div
        data-uipkge
        data-slot="json-tree-view"
        :class="cn('bg-background flex flex-col overflow-hidden rounded-lg border font-mono text-sm', props.class)"
      >
        <!-- Toolbar -->
        <div v-if="showToolbar || showSearch" class="border-border flex items-center gap-2 border-b px-3 py-2">
          <div class="flex items-center gap-1.5">
            <Braces class="text-muted-foreground size-4" />
            <span class="text-muted-foreground text-xs">{{ summary }}</span>
          </div>
          <div class="ml-auto flex items-center gap-1">
            <div v-if="showSearch" class="relative">
              <Search class="text-muted-foreground absolute top-1/2 left-2 size-3.5 -translate-y-1/2" />
              <input
                v-model="search"
                type="text"
                placeholder="Filter..."
                aria-label="Filter JSON tree"
                class="border-input bg-muted/40 focus:border-ring focus:ring-ring/30 h-7 w-32 rounded-md pr-2 pl-7 text-xs transition-[width] outline-none focus:w-44 focus:ring-2"
              />
            </div>
            <span v-if="search" class="text-muted-foreground text-xs"
              >{{ searchMatchCount }} match{{ searchMatchCount === 1 ? '' : 'es' }}</span
            >
            <button
              type="button"
              class="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-7 items-center justify-center rounded-md transition-colors"
              title="Expand all"
              aria-label="Expand all"
              @click="expandAll"
            >
              <UnfoldVertical class="size-4" />
            </button>
            <button
              type="button"
              class="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-7 items-center justify-center rounded-md transition-colors"
              title="Collapse all"
              aria-label="Collapse all"
              @click="collapseAll"
            >
              <FoldVertical class="size-4" />
            </button>
          </div>
        </div>
    
        <!-- Tree -->
        <div class="min-h-0 flex-1 overflow-auto p-2" role="tree" :aria-label="rootLabel">
          <JsonTreeNode
            :data="data"
            :path="[]"
            :label="rootLabel"
            :is-root="true"
            :search="search"
            :max-depth="maxDepth"
            :matches-search="matchesSearch"
            :is-expanded="isExpanded"
            :toggle="toggle"
            :type-of="typeOf"
            :format-value="formatValue"
            :type-color="typeColor"
            :key-color="keyColor"
            :copied-path="copiedPath"
            @copy="copyValue"
          />
        </div>
      </div>
    </template>
  • app/components/ui/json-tree-view/JsonTreeNode.vue 8.9 kB
    <script setup lang="ts">
    import { computed, defineAsyncComponent } from 'vue'
    import { ChevronDown, ChevronRight, Copy, Check } from 'lucide-vue-next'
    import type { JsonValue } from './types'
    
    // Self-reference for recursive rendering — use defineAsyncComponent to avoid circular import
    const JsonTreeNode = defineAsyncComponent(() => import('./JsonTreeNode.vue'))
    
    interface Props {
      data: JsonValue
      path: (string | number)[]
      label: string
      isRoot?: boolean
      search?: string
      maxDepth?: number
      matchesSearch: (val: JsonValue) => boolean
      isExpanded: (path: (string | number)[]) => boolean
      toggle: (path: (string | number)[]) => void
      typeOf: (val: JsonValue) => 'object' | 'array' | 'string' | 'number' | 'boolean' | 'null'
      formatValue: (val: JsonValue) => string
      typeColor: Record<string, string>
      keyColor: string
      copiedPath?: string | null
    }
    
    const props = withDefaults(defineProps<Props>(), {
      isRoot: false,
      search: '',
      maxDepth: 100,
      copiedPath: null,
    })
    
    const emit = defineEmits<{
      copy: [value: JsonValue, path: (string | number)[]]
    }>()
    
    function pathKey(path: (string | number)[]): string {
      return path.length ? path.map((p) => (typeof p === 'number' ? `[${p}]` : `.${p}`)).join('') : '$'
    }
    
    const key = computed(() => pathKey(props.path))
    const type = computed(() => props.typeOf(props.data))
    const open = computed(() => props.isExpanded(props.path))
    const isContainer = computed(() => type.value === 'object' || type.value === 'array')
    const dimmed = computed(() => !!props.search && !props.matchesSearch(props.data))
    
    const entries = computed<[string | number, JsonValue][]>(() => {
      const val = props.data
      if (Array.isArray(val)) return val.map((v, i) => [i, v] as const)
      if (val !== null && typeof val === 'object') return Object.entries(val) as [string, JsonValue][]
      return []
    })
    
    const count = computed(() => entries.value.length)
    const indent = computed(() => (props.isRoot ? 0 : 20))
    
    // Collapsed preview: show first few items inline
    const collapsedPreview = computed(() => {
      if (open.value || !isContainer.value) return ''
      const items = entries.value.slice(0, 3)
      const parts = items.map(([k, v]) => {
        const vt = props.typeOf(v)
        let valStr: string
        if (vt === 'string') valStr = `"${String(v).slice(0, 20)}"`
        else if (vt === 'array') valStr = '[…]'
        else if (vt === 'object') valStr = '{…}'
        else valStr = props.formatValue(v)
        return `${Array.isArray(props.data) ? '' : `"${k}": `}${valStr}`
      })
      const suffix = count.value > 3 ? ', …' : ''
      const open2 = type.value === 'array' ? '[' : '{'
      const close = type.value === 'array' ? ']' : '}'
      return `${open2}${parts.join(', ')}${suffix}${close}`
    })
    
    const parentKey = computed(() => {
      if (!props.path.length) return null
      return pathKey(props.path.slice(0, -1))
    })
    
    function onCopy() {
      emit('copy', props.data, props.path)
    }
    
    function getTreeRows(from: HTMLElement): HTMLElement[] {
      const tree = from.closest('[role="tree"]')
      if (!tree) return []
      return Array.from(tree.querySelectorAll<HTMLElement>('[data-tree-row]'))
    }
    
    function focusRow(row: HTMLElement | null | undefined) {
      row?.focus()
    }
    
    function handleRowKeydown(e: KeyboardEvent) {
      const target = e.currentTarget as HTMLElement
    
      if (e.key === 'Enter' || e.key === ' ') {
        if (isContainer.value) {
          e.preventDefault()
          props.toggle(props.path)
        } else {
          e.preventDefault()
          onCopy()
        }
        return
      }
    
      if (e.key === 'ArrowRight') {
        e.preventDefault()
        if (isContainer.value && !open.value) {
          props.toggle(props.path)
        } else if (isContainer.value && open.value) {
          const rows = getTreeRows(target)
          const idx = rows.indexOf(target)
          if (idx >= 0 && idx < rows.length - 1) focusRow(rows[idx + 1])
        }
        return
      }
    
      if (e.key === 'ArrowLeft') {
        e.preventDefault()
        if (isContainer.value && open.value) {
          props.toggle(props.path)
        } else if (parentKey.value) {
          const tree = target.closest('[role="tree"]')
          const parent = tree?.querySelector<HTMLElement>(`[data-tree-row][data-tree-id="${CSS.escape(parentKey.value)}"]`)
          focusRow(parent)
        }
        return
      }
    
      if (e.key === 'ArrowDown' || e.key === 'ArrowUp') {
        e.preventDefault()
        const rows = getTreeRows(target)
        const idx = rows.indexOf(target)
        if (idx < 0) return
        focusRow(e.key === 'ArrowDown' ? rows[idx + 1] : rows[idx - 1])
        return
      }
    
      if (e.key === 'Home') {
        e.preventDefault()
        focusRow(getTreeRows(target)[0])
        return
      }
    
      if (e.key === 'End') {
        e.preventDefault()
        const rows = getTreeRows(target)
        focusRow(rows[rows.length - 1])
      }
    }
    </script>
    
    <template>
      <div
        :data-dimmed="dimmed ? '' : undefined"
        :class="dimmed ? 'opacity-30' : ''"
        role="treeitem"
        :aria-expanded="isContainer ? open : undefined"
      >
        <!-- Container header row (object/array) -->
        <div
          v-if="isContainer"
          data-tree-row
          :data-tree-id="key"
          :data-tree-parent="parentKey ?? undefined"
          tabindex="0"
          class="group hover:bg-accent/40 focus-visible:ring-ring/50 -mx-1 flex items-center gap-0.5 rounded px-1 py-0.5 transition-colors focus-visible:ring-2 focus-visible:outline-none"
          :style="{ paddingLeft: `${indent}px` }"
          @click="toggle(path)"
          @keydown="handleRowKeydown"
        >
          <button
            type="button"
            class="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-4 shrink-0 items-center justify-center rounded"
            :aria-expanded="open"
            :aria-label="open ? 'Collapse' : 'Expand'"
            tabindex="-1"
            @click.stop="toggle(path)"
          >
            <ChevronDown v-if="open" class="size-3.5" />
            <ChevronRight v-else class="size-3.5" />
          </button>
          <span :class="keyColor" class="select-none">
            {{ isRoot ? label : `"${label}"` }}
          </span>
          <span class="text-muted-foreground">:</span>
          <span v-if="open" class="text-muted-foreground select-none">{{ type === 'array' ? '[' : '{' }}</span>
          <span v-else class="text-muted-foreground select-none">{{ collapsedPreview }}</span>
          <span v-if="open" class="text-muted-foreground ml-0.5 text-xs"
            >{{ count }} {{ count === 1 ? 'item' : 'items' }}</span
          >
          <button
            type="button"
            class="text-muted-foreground hover:text-foreground focus-visible:ring-ring ml-auto inline-flex size-5 items-center justify-center rounded opacity-0 transition-opacity group-focus-within:opacity-100 group-hover:opacity-100 focus-visible:opacity-100 focus-visible:ring-1"
            title="Copy value"
            aria-label="Copy value"
            tabindex="-1"
            @click.stop="onCopy"
          >
            <Check v-if="copiedPath === key" class="size-3 text-emerald-500" />
            <Copy v-else class="size-3" />
          </button>
        </div>
    
        <!-- Container children -->
        <div v-if="isContainer && open" role="group">
          <JsonTreeNode
            v-for="[k, v] in entries"
            :key="String(k)"
            :data="v"
            :path="[...path, k]"
            :label="String(k)"
            :is-root="false"
            :search="search"
            :max-depth="maxDepth"
            :matches-search="matchesSearch"
            :is-expanded="isExpanded"
            :toggle="toggle"
            :type-of="typeOf"
            :format-value="formatValue"
            :type-color="typeColor"
            :key-color="keyColor"
            :copied-path="copiedPath"
            @copy="(val, p) => emit('copy', val, p)"
          />
          <div class="text-muted-foreground py-0.5 select-none" :style="{ paddingLeft: `${indent}px` }">
            {{ type === 'array' ? ']' : '}' }}
          </div>
        </div>
    
        <!-- Primitive leaf -->
        <div
          v-if="!isContainer"
          data-tree-row
          :data-tree-id="key"
          :data-tree-parent="parentKey ?? undefined"
          tabindex="0"
          class="group hover:bg-accent/40 focus-visible:ring-ring/50 -mx-1 flex items-center gap-0.5 rounded px-1 py-0.5 transition-colors focus-visible:ring-2 focus-visible:outline-none"
          :style="{ paddingLeft: `${indent}px` }"
          @click="onCopy"
          @keydown="handleRowKeydown"
        >
          <span class="inline-flex size-4 shrink-0" />
          <span v-if="isRoot" class="text-muted-foreground select-none">{{ label }}</span>
          <span v-else :class="keyColor" class="select-none">"{{ label }}"</span>
          <span class="text-muted-foreground">:</span>
          <span :class="typeColor[type] ?? 'text-foreground'" class="rounded text-left font-mono">
            {{ formatValue(data) }}
          </span>
          <button
            type="button"
            class="text-muted-foreground hover:text-foreground focus-visible:ring-ring ml-auto inline-flex size-5 items-center justify-center rounded opacity-0 transition-opacity group-focus-within:opacity-100 group-hover:opacity-100 focus-visible:opacity-100 focus-visible:ring-1"
            title="Copy value"
            aria-label="Copy value"
            tabindex="-1"
            @click.stop="onCopy"
          >
            <Check v-if="copiedPath === key" class="size-3 text-emerald-500" />
            <Copy v-else class="size-3" />
          </button>
        </div>
      </div>
    </template>
  • app/components/ui/json-tree-view/types.ts 0.1 kB
    export type JsonValue = string | number | boolean | null | JsonValue[] | { [key: string]: JsonValue }
  • app/components/ui/json-tree-view/index.ts 0.2 kB
    export { default as JsonTreeView } from './JsonTreeView.vue'
    export { default as JsonTreeNode } from './JsonTreeNode.vue'
    export type { JsonValue } from './types'

Raw manifest: https://uipkge.dev/r/vue/json-tree-view.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Json Tree View

json-tree-view ui
Boilerplate repo

Collapsible JSON tree viewer with color-coded value types, click-to-copy, live search/filter, and expand/collapse-all controls. Renders objects, arrays, and primitives with configurable depth and contained scrolling.

Also available for Vue ->

Installation

$ npx shadcn@latest add https://uipkge.dev/r/react/json-tree-view.json
Named registry: npx shadcn@latest add @uipkge-react/json-tree-view Installs to: components/ui/json-tree-view/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
data JsonValue required
expandDepth number optional
maxDepth number optional
showSearch boolean optional
showToolbar boolean optional
rootLabel string optional
onCopy (value: string, path: string) => void optional

npm dependencies

Files installed (4)

  • components/ui/json-tree-view/JsonTreeView.tsx 9.6 kB
    import * as React from 'react'
    import { Search, Braces, FoldVertical, UnfoldVertical } from 'lucide-react'
    import { cn } from '@/lib/utils'
    import { JsonTreeNode } from './JsonTreeNode'
    import type { JsonValue } from './types'
    
    export type { JsonValue } from './types'
    
    export interface JsonTreeViewProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'data' | 'onCopy'> {
      data: JsonValue
      expandDepth?: number
      maxDepth?: number
      showSearch?: boolean
      showToolbar?: boolean
      rootLabel?: string
      onCopy?: (value: string, path: string) => void
    }
    
    function pathKey(path: (string | number)[]): string {
      return path.length ? path.map((p) => (typeof p === 'number' ? `[${p}]` : `.${p}`)).join('') : '$'
    }
    
    function typeOf(val: JsonValue): 'object' | 'array' | 'string' | 'number' | 'boolean' | 'null' {
      if (val === null) return 'null'
      if (Array.isArray(val)) return 'array'
      return typeof val as 'object' | 'string' | 'number' | 'boolean'
    }
    
    function formatValue(val: JsonValue): string {
      if (val === null) return 'null'
      if (typeof val === 'string') return JSON.stringify(val)
      return String(val)
    }
    
    const typeColor: Record<string, string> = {
      string: 'text-emerald-600 dark:text-emerald-400',
      number: 'text-blue-600 dark:text-blue-400',
      boolean: 'text-amber-600 dark:text-amber-400',
      null: 'text-muted-foreground italic',
      object: 'text-foreground',
      array: 'text-foreground',
    }
    
    const keyColor = 'text-violet-600 dark:text-violet-400'
    
    const JsonTreeView = React.forwardRef<HTMLDivElement, JsonTreeViewProps>(function JsonTreeView(props, ref) {
      const {
        data,
        expandDepth = 1,
        maxDepth = 100,
        showSearch = true,
        showToolbar = true,
        rootLabel = 'root',
        onCopy,
        className,
        ...rest
      } = props
    
      const [expanded, setExpanded] = React.useState<Set<string>>(() => new Set())
      const [search, setSearch] = React.useState('')
      const [copiedPath, setCopiedPath] = React.useState<string | null>(null)
    
      const dataRef = React.useRef(data)
      dataRef.current = data
      const expandDepthRef = React.useRef(expandDepth)
      expandDepthRef.current = expandDepth
      const maxDepthRef = React.useRef(maxDepth)
      maxDepthRef.current = maxDepth
    
      function defaultExpanded(): Set<string> {
        const next = new Set<string>()
        const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
          if (depth >= expandDepthRef.current) return
          if (val !== null && typeof val === 'object') {
            next.add(pathKey(path))
            const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
            for (const [k, v] of entries) {
              walk(v as JsonValue, [...path, k], depth + 1)
            }
          }
        }
        walk(dataRef.current)
        return next
      }
    
      // Reset expanded state when data or expandDepth changes
      React.useEffect(() => {
        setExpanded(defaultExpanded())
        // eslint-disable-next-line react-hooks/exhaustive-deps
      }, [data, expandDepth])
    
      function toggle(path: (string | number)[]) {
        const k = pathKey(path)
        setExpanded((prev) => {
          const next = new Set(prev)
          if (next.has(k)) next.delete(k)
          else next.add(k)
          return next
        })
      }
    
      function isExpanded(path: (string | number)[]): boolean {
        return expanded.has(pathKey(path))
      }
    
      function expandAll() {
        const next = new Set<string>()
        const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
          if (depth >= maxDepthRef.current) return
          if (val !== null && typeof val === 'object') {
            next.add(pathKey(path))
            const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
            for (const [k, v] of entries) {
              walk(v as JsonValue, [...path, k], depth + 1)
            }
          }
        }
        walk(dataRef.current)
        setExpanded(next)
      }
    
      function collapseAll() {
        setExpanded(new Set())
      }
    
      function matchesSearch(val: JsonValue): boolean {
        if (!search) return true
        const term = search.toLowerCase()
        const walk = (v: JsonValue): boolean => {
          if (v === null) return 'null'.includes(term)
          if (typeof v === 'string') return v.toLowerCase().includes(term)
          if (typeof v === 'number' || typeof v === 'boolean') return String(v).includes(term)
          if (Array.isArray(v)) return v.some(walk)
          if (typeof v === 'object')
            return Object.entries(v).some(([k, value]) => k.toLowerCase().includes(term) || walk(value))
          return false
        }
        return walk(val)
      }
    
      // Auto-expand nodes that contain search matches
      React.useEffect(() => {
        if (!search) {
          setExpanded(defaultExpanded())
          return
        }
        const next = new Set<string>()
        const walk = (val: JsonValue, path: (string | number)[] = [], depth = 0) => {
          if (depth >= maxDepthRef.current) return
          if (val !== null && typeof val === 'object') {
            if (matchesSearch(val)) next.add(pathKey(path))
            const entries = Array.isArray(val) ? val.map((v, i) => [i, v] as const) : Object.entries(val)
            for (const [k, v] of entries) {
              walk(v as JsonValue, [...path, k], depth + 1)
            }
          }
        }
        walk(dataRef.current)
        setExpanded(next)
        // eslint-disable-next-line react-hooks/exhaustive-deps
      }, [search])
    
      async function copyValue(val: JsonValue, path: (string | number)[]) {
        const str = typeof val === 'string' ? val : JSON.stringify(val, null, 2)
        const p = pathKey(path)
        try {
          await navigator.clipboard.writeText(str)
          setCopiedPath(p)
          onCopy?.(str, p)
          setTimeout(() => {
            setCopiedPath((cur) => (cur === p ? null : cur))
          }, 1200)
        } catch {
          // clipboard unavailable
        }
      }
    
      const summary = React.useMemo(() => {
        const t = typeOf(data)
        if (t === 'array') return `Array(${(data as JsonValue[]).length})`
        if (t === 'object') return `Object(${Object.keys(data as object).length})`
        return t
      }, [data])
    
      const searchMatchCount = React.useMemo(() => {
        if (!search) return 0
        let count = 0
        const term = search.toLowerCase()
        const walk = (v: JsonValue) => {
          if (v === null) {
            if ('null'.includes(term)) count++
            return
          }
          if (typeof v === 'string') {
            if (v.toLowerCase().includes(term)) count++
            return
          }
          if (typeof v === 'number' || typeof v === 'boolean') {
            if (String(v).includes(term)) count++
            return
          }
          if (Array.isArray(v)) {
            v.forEach(walk)
            return
          }
          if (typeof v === 'object') {
            Object.entries(v).forEach(([k, val]) => {
              if (k.toLowerCase().includes(term)) count++
              walk(val)
            })
          }
        }
        walk(data)
        return count
      }, [search, data])
    
      return (
        <div
          ref={ref}
          data-uipkge=""
          data-slot="json-tree-view"
          className={cn('bg-background flex flex-col overflow-hidden rounded-lg border font-mono text-sm', className)}
          {...rest}
        >
          {/* Toolbar */}
          {(showToolbar || showSearch) && (
            <div className="border-border flex items-center gap-2 border-b px-3 py-2">
              <div className="flex items-center gap-1.5">
                <Braces className="text-muted-foreground size-4" />
                <span className="text-muted-foreground text-xs">{summary}</span>
              </div>
              <div className="ml-auto flex items-center gap-1">
                {showSearch && (
                  <div className="relative">
                    <Search className="text-muted-foreground absolute top-1/2 left-2 size-3.5 -translate-y-1/2" />
                    <input
                      type="text"
                      value={search}
                      onChange={(e) => setSearch(e.target.value)}
                      placeholder="Filter..."
                      aria-label="Filter JSON tree"
                      className="border-input bg-muted/40 focus:border-ring focus:ring-ring/30 h-7 w-32 rounded-md pr-2 pl-7 text-xs transition-[width] outline-none focus:w-44 focus:ring-2"
                    />
                  </div>
                )}
                {search && (
                  <span className="text-muted-foreground text-xs">
                    {searchMatchCount} match{searchMatchCount === 1 ? '' : 'es'}
                  </span>
                )}
                <button
                  type="button"
                  className="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-7 items-center justify-center rounded-md transition-colors"
                  title="Expand all"
                  aria-label="Expand all"
                  onClick={expandAll}
                >
                  <UnfoldVertical className="size-4" />
                </button>
                <button
                  type="button"
                  className="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-7 items-center justify-center rounded-md transition-colors"
                  title="Collapse all"
                  aria-label="Collapse all"
                  onClick={collapseAll}
                >
                  <FoldVertical className="size-4" />
                </button>
              </div>
            </div>
          )}
    
          {/* Tree */}
          <div className="min-h-0 flex-1 overflow-auto p-2" role="tree" aria-label={rootLabel}>
            <JsonTreeNode
              data={data}
              path={[]}
              label={rootLabel}
              isRoot
              search={search}
              maxDepth={maxDepth}
              matchesSearch={matchesSearch}
              isExpanded={isExpanded}
              toggle={toggle}
              typeOf={typeOf}
              formatValue={formatValue}
              typeColor={typeColor}
              keyColor={keyColor}
              copiedPath={copiedPath}
              onCopy={copyValue}
            />
          </div>
        </div>
      )
    })
    
    JsonTreeView.displayName = 'JsonTreeView'
    
    export { JsonTreeView }
  • components/ui/json-tree-view/JsonTreeNode.tsx 9.4 kB
    import * as React from 'react'
    import { ChevronDown, ChevronRight, Copy, Check } from 'lucide-react'
    import type { JsonValue } from './types'
    
    export interface JsonTreeNodeProps {
      data: JsonValue
      path: (string | number)[]
      label: string
      isRoot?: boolean
      search?: string
      maxDepth?: number
      matchesSearch: (val: JsonValue) => boolean
      isExpanded: (path: (string | number)[]) => boolean
      toggle: (path: (string | number)[]) => void
      typeOf: (val: JsonValue) => 'object' | 'array' | 'string' | 'number' | 'boolean' | 'null'
      formatValue: (val: JsonValue) => string
      typeColor: Record<string, string>
      keyColor: string
      copiedPath?: string | null
      onCopy?: (value: JsonValue, path: (string | number)[]) => void
    }
    
    function pathKey(path: (string | number)[]): string {
      return path.length ? path.map((p) => (typeof p === 'number' ? `[${p}]` : `.${p}`)).join('') : '$'
    }
    
    function JsonTreeNode(props: JsonTreeNodeProps): React.ReactElement {
      const {
        data,
        path,
        label,
        isRoot = false,
        search = '',
        maxDepth = 100,
        matchesSearch,
        isExpanded,
        toggle,
        typeOf,
        formatValue,
        typeColor,
        keyColor,
        copiedPath = null,
        onCopy,
      } = props
    
      const key = pathKey(path)
      const type = typeOf(data)
      const open = isExpanded(path)
      const isContainer = type === 'object' || type === 'array'
      const dimmed = !!search && !matchesSearch(data)
    
      const entries: [string | number, JsonValue][] = React.useMemo(() => {
        if (Array.isArray(data)) return data.map((v, i) => [i, v] as [number, JsonValue])
        if (data !== null && typeof data === 'object') return Object.entries(data) as [string, JsonValue][]
        return []
      }, [data])
    
      const count = entries.length
      const indent = isRoot ? 0 : 20
    
      // Collapsed preview: show first few items inline
      const collapsedPreview = React.useMemo(() => {
        if (open || !isContainer) return ''
        const items = entries.slice(0, 3)
        const parts = items.map(([k, v]) => {
          const vt = typeOf(v)
          let valStr: string
          if (vt === 'string') valStr = `"${String(v).slice(0, 20)}"`
          else if (vt === 'array') valStr = '[…]'
          else if (vt === 'object') valStr = '{…}'
          else valStr = formatValue(v)
          return `${Array.isArray(data) ? '' : `"${k}": `}${valStr}`
        })
        const suffix = count > 3 ? ', …' : ''
        const open2 = type === 'array' ? '[' : '{'
        const close = type === 'array' ? ']' : '}'
        return `${open2}${parts.join(', ')}${suffix}${close}`
      }, [open, isContainer, entries, count, type, typeOf, formatValue, data])
    
      const parentKey = path.length ? pathKey(path.slice(0, -1)) : null
    
      function handleCopy() {
        onCopy?.(data, path)
      }
    
      function getTreeRows(from: HTMLElement): HTMLElement[] {
        const tree = from.closest('[role="tree"]')
        if (!tree) return []
        return Array.from(tree.querySelectorAll<HTMLElement>('[data-tree-row]'))
      }
    
      function focusRow(row: HTMLElement | null | undefined) {
        row?.focus()
      }
    
      function handleRowKeydown(e: React.KeyboardEvent) {
        const target = e.currentTarget as HTMLElement
    
        if (e.key === 'Enter' || e.key === ' ') {
          e.preventDefault()
          if (isContainer) toggle(path)
          else handleCopy()
          return
        }
    
        if (e.key === 'ArrowRight') {
          e.preventDefault()
          if (isContainer && !open) {
            toggle(path)
          } else if (isContainer && open) {
            const rows = getTreeRows(target)
            const idx = rows.indexOf(target)
            if (idx >= 0 && idx < rows.length - 1) focusRow(rows[idx + 1])
          }
          return
        }
    
        if (e.key === 'ArrowLeft') {
          e.preventDefault()
          if (isContainer && open) {
            toggle(path)
          } else if (parentKey) {
            const tree = target.closest('[role="tree"]')
            const parent = tree?.querySelector<HTMLElement>(`[data-tree-row][data-tree-id="${CSS.escape(parentKey)}"]`)
            focusRow(parent)
          }
          return
        }
    
        if (e.key === 'ArrowDown' || e.key === 'ArrowUp') {
          e.preventDefault()
          const rows = getTreeRows(target)
          const idx = rows.indexOf(target)
          if (idx < 0) return
          focusRow(e.key === 'ArrowDown' ? rows[idx + 1] : rows[idx - 1])
          return
        }
    
        if (e.key === 'Home') {
          e.preventDefault()
          focusRow(getTreeRows(target)[0])
          return
        }
    
        if (e.key === 'End') {
          e.preventDefault()
          const rows = getTreeRows(target)
          focusRow(rows[rows.length - 1])
        }
      }
    
      return (
        <div
          data-dimmed={dimmed ? '' : undefined}
          className={dimmed ? 'opacity-30' : ''}
          role="treeitem"
          aria-expanded={isContainer ? open : undefined}
        >
          {/* Container header row (object/array) */}
          {isContainer && (
            <div
              data-tree-row
              data-tree-id={key}
              data-tree-parent={parentKey ?? undefined}
              tabIndex={0}
              className="group hover:bg-accent/40 focus-visible:ring-ring/50 -mx-1 flex items-center gap-0.5 rounded px-1 py-0.5 transition-colors focus-visible:ring-2 focus-visible:outline-none"
              style={{ paddingLeft: `${indent}px` }}
              onClick={() => toggle(path)}
              onKeyDown={handleRowKeydown}
            >
              <button
                type="button"
                className="text-muted-foreground hover:text-foreground hover:bg-accent inline-flex size-4 shrink-0 items-center justify-center rounded"
                aria-expanded={open}
                aria-label={open ? 'Collapse' : 'Expand'}
                tabIndex={-1}
                onClick={(e) => {
                  e.stopPropagation()
                  toggle(path)
                }}
              >
                {open ? <ChevronDown className="size-3.5" /> : <ChevronRight className="size-3.5" />}
              </button>
              <span className={`${keyColor} select-none`}>{isRoot ? label : `"${label}"`}</span>
              <span className="text-muted-foreground">:</span>
              {open ? (
                <span className="text-muted-foreground select-none">{type === 'array' ? '[' : '{'}</span>
              ) : (
                <span className="text-muted-foreground select-none">{collapsedPreview}</span>
              )}
              {open && (
                <span className="text-muted-foreground ml-0.5 text-xs">
                  {count} {count === 1 ? 'item' : 'items'}
                </span>
              )}
              <button
                type="button"
                className="text-muted-foreground hover:text-foreground focus-visible:ring-ring ml-auto inline-flex size-5 items-center justify-center rounded opacity-0 transition-opacity group-focus-within:opacity-100 group-hover:opacity-100 focus-visible:opacity-100 focus-visible:ring-1"
                title="Copy value"
                aria-label="Copy value"
                tabIndex={-1}
                onClick={(e) => {
                  e.stopPropagation()
                  handleCopy()
                }}
              >
                {copiedPath === key ? <Check className="size-3 text-emerald-500" /> : <Copy className="size-3" />}
              </button>
            </div>
          )}
    
          {/* Container children */}
          {isContainer && open && (
            <div role="group">
              {entries.map(([k, v]) => (
                <JsonTreeNode
                  key={String(k)}
                  data={v}
                  path={[...path, k]}
                  label={String(k)}
                  isRoot={false}
                  search={search}
                  maxDepth={maxDepth}
                  matchesSearch={matchesSearch}
                  isExpanded={isExpanded}
                  toggle={toggle}
                  typeOf={typeOf}
                  formatValue={formatValue}
                  typeColor={typeColor}
                  keyColor={keyColor}
                  copiedPath={copiedPath}
                  onCopy={onCopy}
                />
              ))}
              <div className="text-muted-foreground py-0.5 select-none" style={{ paddingLeft: `${indent}px` }}>
                {type === 'array' ? ']' : '}'}
              </div>
            </div>
          )}
    
          {/* Primitive leaf */}
          {!isContainer && (
            <div
              data-tree-row
              data-tree-id={key}
              data-tree-parent={parentKey ?? undefined}
              tabIndex={0}
              className="group hover:bg-accent/40 focus-visible:ring-ring/50 -mx-1 flex items-center gap-0.5 rounded px-1 py-0.5 transition-colors focus-visible:ring-2 focus-visible:outline-none"
              style={{ paddingLeft: `${indent}px` }}
              onClick={handleCopy}
              onKeyDown={handleRowKeydown}
            >
              <span className="inline-flex size-4 shrink-0" />
              {isRoot ? (
                <span className="text-muted-foreground select-none">{label}</span>
              ) : (
                <span className={`${keyColor} select-none`}>"{label}"</span>
              )}
              <span className="text-muted-foreground">:</span>
              <span className={`${typeColor[type] ?? 'text-foreground'} rounded text-left font-mono`}>
                {formatValue(data)}
              </span>
              <button
                type="button"
                className="text-muted-foreground hover:text-foreground focus-visible:ring-ring ml-auto inline-flex size-5 items-center justify-center rounded opacity-0 transition-opacity group-focus-within:opacity-100 group-hover:opacity-100 focus-visible:opacity-100 focus-visible:ring-1"
                title="Copy value"
                aria-label="Copy value"
                tabIndex={-1}
                onClick={(e) => {
                  e.stopPropagation()
                  handleCopy()
                }}
              >
                {copiedPath === key ? <Check className="size-3 text-emerald-500" /> : <Copy className="size-3" />}
              </button>
            </div>
          )}
        </div>
      )
    }
    
    export { JsonTreeNode }
  • components/ui/json-tree-view/types.ts 0.1 kB
    export type JsonValue = string | number | boolean | null | JsonValue[] | { [key: string]: JsonValue }
  • components/ui/json-tree-view/index.ts 0.2 kB
    export { JsonTreeView, type JsonTreeViewProps } from './JsonTreeView'
    export { JsonTreeNode, type JsonTreeNodeProps } from './JsonTreeNode'
    export type { JsonValue } from './types'

Raw manifest: https://uipkge.dev/r/react/json-tree-view.json